(function($, globals) {

	"use strict";

	var ams = globals.MyAMS;

	var PyAMS_media = {

		initPlayer: function(element) {
			ams.ajax.check($.fn.flowplayer,
							 '/--static--/pyams_media/flowplayer/flowplayer' + ams.devext + '.js',
							 function(first_load) {
								if (first_load) {
									ams.dialog && ams.dialog.registerShownCallback(PyAMS_media.initPlayerDialog, player);
									ams.dialog && ams.dialog.registerHideCallback(PyAMS_media.shutdownPlayerDialog, player);
								}
								var player = $(element);
								var flowplayer = player.flowplayer();
								var events = player.data('ams-flowplayer-events');
								if (events) {
									for (var event in events) {
										if (!events.hasOwnProperty(event)) {
											continue;
										}
										flowplayer.on(event, MyAMS.getFunctionByName(events[event]));
									}
								}
			});
		},

		initPlayerDialog: function() {
			var dialog = $(this);
			$('.modal-viewport', dialog).removeAttr('style')
										.removeClass('modal-viewport');
		},

		shutdownPlayerDialog: function() {
			var dialog = $(this);
			var player = $('.flowplayer', dialog).data('flowplayer');
			if (player) {
				player.shutdown();
			}
		},

		getPlayerTime: function(/* e, api */) {
			var parent = $(this);
			if (!parent.hasClass('flowplayer')) {
				parent = $('.flowplayer', parent);
			}
			var player = parent.data('flowplayer');
			if (player) {
				var video = player.video;
				if (!video.time && player.conf.flowplayer) {
					video = player.conf.flowplayer.video;
				}
				if (video && video.time) {
					var position = video.time;
					var form = parent.parents('form');
					$('INPUT[name="thumbnail_form.widgets.time"]', form).val(position);
				}
			}
		},

		pausePlayer: function() {
			var form = $(this);
			var player = $('.flowplayer', form).data('flowplayer');
			if (player && player.playing) {
				player.pause();
			}
			PyAMS_media.getPlayerTime.call(form);
			return {};
		}
	};
	globals.PyAMS_media = PyAMS_media;

})(jQuery, this);
